/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *  BEGIN LICENSE BLOCK
 *  Copyright (C) 2004 Davide Carboni
 *
 *  This software is distributed under the terms of GPL
 *  END LICENSE BLOCK
*/

function getCiteDBURI(){
    include(jslib_io);
	include('chrome://jslib/content/io/file.js');
	
    var homeDir=new DirUtils().getMozUserHomeDir();
	
	var citeDBPath=homeDir;;
	
	var f=new File(citeDBPath);
	f.append("citedb.rdf");
	
	if(!f.exists()){
		
		f.create();
		f.open('w'); 
		f.write('<?xml version="1.0"?>\n');
		f.write('<RDF:RDF xmlns:CDB="http://www.citedb.org/rdf#" xmlns:NC="http://home.netscape.com/NC-rdf#"         xmlns:RDF="http://www.w3.org/1999/02/22-rdf-syntax-ns#">\n');
		f.write('<RDF:Seq RDF:about="http://www.citedb.org">\n');
        f.write('<RDF:li RDF:resource="http://www.citedb.org/davide"/>\n');
        f.write('</RDF:Seq>\n');
        f.write('<RDF:Description RDF:about="http://www.citedb.org/davide"\n');
        f.write('CDB:id="001"\n');
        f.write('CDB:author="Davide"\n');
        f.write('CDB:url="http://citations.mozdev.org"\n');
        f.write('CDB:content="citations is a great tool" />\n');
		f.write('</RDF:RDF>');
		f.close();
	}
		
    var URI="file://"+citeDBPath+"/citedb.rdf";
	URI=URI.replace(/\\/g,"/");
    return URI;
}

function saveCiteItem(author,url,content,category){
    var id=Math.ceil(Math.random() * 1000000);
    //alert(URI);
    URI=getCiteDBURI();
    ds=new RDFDataSource(URI);
	
    //alert(ds.serializeToString());
	if(category!="")
		category="/"+category;
	
    list=ds.getNode("http://www.citedb.org"+category);
	
	if(!list.isSeq()){
		list.makeSeq();
		root=ds.getNode("http://www.citedb.org");
		root.addChild(list);
	}
	
    node=ds.getNode("http://www.citedb.org/"+id);
    node=list.addChild(node);
    //alert("addChild done");
    node.addTarget("http://www.citedb.org/rdf#id",id+"");
    //alert("id aggiunto "+id);
    node.addTarget("http://www.citedb.org/rdf#author",author);
    //alert("author "+author);
    node.addTarget("http://www.citedb.org/rdf#url",url);
    //alert("url "+url);
    node.addTarget("http://www.citedb.org/rdf#content",content);
    //alert("content "+content);
    //alert(ds.serializeToString());
    ds.save();
    window.close();
}
